import type { FILE_TYPE, STREAM_TYPE } from '../../types/stream';
export type SearchDate = {
    year: number;
    month: number;
    day: number;
    hour: number;
    minute: number;
    second: number;
};
export type SearchDeviceFilesByDateParams = {
    deviceChannel: number;
    deviceId: string;
    maxFileCount?: number;
    fileType: FILE_TYPE;
    fileName?: string;
    streamType?: STREAM_TYPE;
    start: SearchDate;
    end: SearchDate;
    timeout?: number;
};
export type SearchDeviceFilesByDateItemResponse = {
    size: number;
    channel: number;
    fileName: string;
    streamType: STREAM_TYPE;
    startTime: SearchDate;
    endTime: SearchDate;
};
export declare const searchDeviceFilesByDate: (params: SearchDeviceFilesByDateParams) => Promise<SearchDeviceFilesByDateItemResponse[]>;
//# sourceMappingURL=fileSearch.d.ts.map